﻿$__author__ = "Shagun Agrawal <shaguna@chelsio.com"
$Global:__version__ = "3.0"
$Global:__is_nano  = "empty"
$Global:__ch_cards = @{
    # For internal use only don't modify this.
}

$Global:__ch_parts = @{
}

$Global:__ch_vpd_map = @{
}

$Global:__ch_vpd_revmap = @{
}


$Global:__sys_drive = (Get-ChildItem Env:\SystemDrive).Value

$Global:__vpd_default = @{

        "T580-CR"    = "t580_cr_variable_2133_vpd.bin";
        "T580-LP-CR" = "t580_lp_cr_variable_2133_vpd.bin";
        "T580-SO-CR" = "t580_lp_so_variable_vpd.bin";
        "T580-OCP-SO"= "t580_ocp_so_2x40g_vpd.bin";
        "T6225-CR"   = "t6225_cr_variable_2133_15625_2x25g_vpd.bin";
        "T6-DBG-25"  = "t6_dbg_25_fixed_2133ddr3_15625_2x25g_vpd.bin";
        "T62100-LP-CR" = "t62100_lp_cr_variable_2133_15625_2x100g_vpd.bin";
        "T6-DBG-100"  = "t6_dbg_100_fixed_2133ddr4_15625_2x100g_vpd.bin";
}

$Global:__vpd_spider = @{
        
        "T580-CR"    = "t580_cr_spider_variable_2133_vpd.bin";
        "T580-LP-CR" = "t580_lp_cr_spider_variable_2133_vpd.bin";
        "T580-SO-CR" = "t580_so_spider_variable_2133_vpd.bin";
        "T580-OCP-SO"= "t580_ocp_so_4x10g_vpd.bin";
        "T62100-LP-CR" = "t62100_lp_cr_spider_variable_vpd.bin";
        "T6-DBG-100"  = "t6_dbg_100_spider_variable_vpd.bin";
}

$Global:__vpd_qsa = @{
    
        "T580-CR"    = "t580_cr_qsa_variable_2133_vpd.bin";
        "T580-LP-CR" = "t580_lp_cr_qsa_variable_2133_vpd.bin";
        "T580-SO-CR" = "t580_lp_so_qsa_variable_vpd.bin";
        "T62100-LP-CR" = "t62100_lp_cr_qsa_variable_vpd.bin";
        "T6-DBG-100"  = "t6_dbg_100_qsa_variable_vpd.bin";
}

$Global:__sriov = @{

       "T502-BT"    = "t502_bt_init_gen3_150mhz_Pf4vf.bin";
       "T520-BT"    = "t520_bt_init_gen3_250_820_Pf4vf.bin";
       "T520-CR"    = "t520_cr_init_gen3_250_825_Pf4vf.bin";
       "T520-LL-CR" = "t520_ll_init_gen3_650_1075_Pf4vf.bin";
       "T520-SO"    = "t520_so_init_gen3_250_825_Pf4vf.bin";
       "T522-CR"    = "t522_cr_init_gen3_500mhz_Pf4vf.bin";
       "T540-CR"    = "t540_cr_init_gen3_500_825_Pf4vf.bin";
       "T580-CR"    = "t580_cr_init_gen3_500Mhz_Pf4vf.bin";
       "T580-LP-CR" = "t580_lp_cr_init_gen3_500Mhz_Pf4vf.bin";
       "T580-SO-CR" = "t580_lp_so_init_gen3_500Mhz_Pf4vf.bin";
       "T580-OCP-SO"= "t580_ocp_so_init_gen3_500Mhz_Pf4vf.bin";
       "T520-OCP-SO"= "t520_ocp_init_gen3_250_825_Pf4vf.bin";
       "T540-BT"    = "t540_bt_init_gen3_500_820_Pf4vf.bin";
       "T6225-CR"   = "t6225_cr_init_500_950_gen3_x8_mfg_pf4vf.bin";
       "T6-DBG-25"  = "t6_dbg_25_init_450_950_gen3_x8_pf4vf.bin";
       "T62100-CR"  = "t62100_cr_init_800_950_gen3_x16_mfg_pf4vf.bin";
       "T62100-LP-CR" = "t62100_lp_cr_init_800_950_gen3_x16_mfg_pf4vf.bin";
       "T6-DBG-100"  = "t6_dbg_100_init_800_950_gen3_x16_pf4vf.bin";
}

$Global:__default_init = @{
    
       "T502-BT"    = "t502_bt_init_gen3_150mhz.bin";
       "T520-BT"    = "t520_bt_init_gen3_250_820.bin";
       "T520-CR"    = "t520_cr_init_gen3_250_825.bin";
       "T520-LL-CR" = "t520_ll_init_gen3_650_1075.bin";
       "T520-SO"    = "t520_so_init_gen3_250_825.bin";
       "T522-CR"    = "t522_cr_init_gen3_500mhz.bin";
       "T540-CR"    = "t540_cr_init_gen3_500_825.bin";
       "T580-CR"    = "t580_cr_init_gen3_500Mhz.bin";
       "T580-LP-CR" = "t580_lp_cr_init_gen3_500Mhz.bin";
       "T580-SO-CR" = "t580_lp_so_init_gen3_500Mhz.bin";
       "T580-OCP-SO"= "t580_ocp_so_init_gen3_500Mhz.bin";
       "T520-OCP-SO"= "t520_ocp_init_gen3_250_825.bin";
       "T540-BT"    = "t540_bt_init_gen3_500_820.bin";
       "T6225-CR"   = "t6225_cr_init_500_950_gen3_x8_mfg.bin";
       "T6-DBG-25"  = "t6_dbg_25_init_450_950_gen3_x8_mfg.bin";
       "T62100-CR"  = "t62100_cr_init_800_950_gen3_x16_mfg.bin";
       "T62100-LP-CR" = "t62100_lp_cr_init_800_950_gen3_x16_mfg.bin";
       "T6-DBG-100"  = "t6_dbg_100_init_800_950_gen3_x16.bin";
}

$Global:device_map = @{

        # Maps device ids to human readable names.

        "B000"    = "Bypass Mode";
        "5400"    = "T580-dbg";
        "5401"    = "T520-CR";
        "5402"    = "T522-CR";
        "5403"    = "T540-CR";
        "5404"    = "T520-BCH";
        "5405"    = "T540-BCH";
        "5406"    = "T540-CH";
        "5407"    = "T520-SO";
        "5408"    = "T520-CX";
        "5409"    = "T520-BT";
        "540A"    = "T504-BT";
        "540B"    = "B520-SR";
        "540C"    = "B504-BT";
        "540D"    = "T580-CR";
        "540E"    = "T540-LP-CR";
        "540F"    = "Amsterdam";

        "5410"    = "T580-LP-CR";
        "5411"    = "T520-LL-CR";
        "5412"    = "T560-CR";
        "5413"    = "T580-CHR";
        "5414"    = "T580-SO-CR";
        "5415"    = "T502-BT";
        "5416"    = "T580-OCP-SO";
        "5417"    = "T520-OCP-SO";
        "5418"    = "T540-BT";

        "5480"    = "SECUI";
        "5481"    = "SECUI-LL";
        "5482"    = "SECUI-1G";

        "5483"    = "HUAWEI-T540-CANCELED";
        "5484"    = "HUAWEI-T580-CALCELED";
        "5485"    = "HUAWEI-3XT580-CANCELED";
        "5486"    = "HUAWEI-2XT580";
        "5487"    = "Dell Harpoon";
        "5488"    = "Xalyo T570";
        "5489"    = "KTFN T520";
        "5490"    = "KTFN T540";

        "5491"    = "Huawei T522 LOM";
        "5492"    = "Datawise T520-XFI";
        "6401"    = "T6225-CR";
        "6400"    = "T6-DBG-25";
        "6407"    = "T62100-LP-CR";
        "640D"    = "T62100-CR";
        "6410"    = "T6-DBG-100";
        
        <#
        "5800"    = "";
        "5801"    = "";
        "5802"    = "";
        "5803"    = "";
        "5804"    = "";
        "5805"    = "";
        "5806"    = "";
        "5807"    = "";
        "5808"    = "";
        "5809"    = "";
        "580A"    = "";
        "580B"    = "";
        "580C"    = "";
        "580D"    = "";
        "580E"    = "";
        "5810"    = "";
        "5811"    = "";
        "5812"    = "";
        "5813"    = "";
        "5814"    = "";
        "5815"    = "";
        "5816"    = "";
        "5817"    = "";
        "5818"    = "";
        "5880"    = "";
        "5881"    = "";
        "5883"    = "";
        "5884"    = "";
        "5885"    = "";
        "5886"    = "";
        "5887"    = "";
        "5888"    = "";
        "5889"    = "";
        "5890"    = "";
        #>
        
}

function is_cxgbtool_present ()
{
        return Test-Path C:\Windows\System32\cxgbtool.exe
}
  
function is_cxgbnano_present()
{
        return Test-Path C:\Windows\System32\cxgbnano.exe
}

function is_ms_nano_server()
{
        
        if ($Global:__is_nano -eq "empty") {
            Write-Host "    1.  Windows GUI"
            Write-Host "    2.  Windows Nano Server"
            $Global:__is_nano = READ-HOST 'Input'

        }

        if ($Global:__is_nano -eq '1') {
            return 0
        }
        elseif ($Global:__is_nano -eq '2') {
            return 1
        }
        else {
            Write-Host "Wrong input"
            exit(1)
        }
        
}

function get_cxgbtool()
{
    if (is_ms_nano_server) {
        return "cxgbnano.exe"
    }
    else {
        return "cxgbtool.exe"
    }
}

function get_chelsio_card_count ()
{
        if ((Test-Path "HKLM:\SYSTEM\CurrentControlSet\Services\chvbd\Enum") -eq $false) {
            return $false
        }
        
        $out = Get-ItemProperty "HKLM:\SYSTEM\CurrentControlSet\Services\chvbd\Enum"      
        return $out.Count
}


function __extract_devid ([string] $str)
{
        
        $tmp = $str -replace '\s+', ' '
        return $tmp.Split(' ')[1].trim().ToString()
}


function __extract_partno ([string] $str)
{
       
        $tmp = $str -replace '\s+', ' '
        return $tmp.Split(' ')[1].trim().ToString()
}


function get_pci_device ([int] $num)
{ 
        $cmd = "$(get_cxgbtool) vbd$num version"
        
        $out = Invoke-Expression -Command $cmd
      
        for ($i=0; $i -le $out.Length-1; $i++){
               
                if ($out[$i].Contains("DeviceId:") -eq $true){
                        $dev_id = __extract_devid $out[$i]
                }

                if ($out[$i].Contains("S/N:") -eq $true){
                        $part = __extract_partno $out[$i]     
                }
        }
        
        return $dev_id, $part
}


function __is_chelsio_card ([string] $device)
{
        foreach ( $key in ($device_map.GetEnumerator())){
                if ($device.Contains($key.name.ToLower())){
                    return $true, $key.value
            }
        }

}


function __add_device ([int] $vpd_count, [int]$count, [string] $name, [string] $part)
{
        $Global:__ch_cards.Add($vpd_count, $name)
        $Global:__ch_parts.Add($vpd_count, "S/N:" + $part)
        $Global:__ch_vpd_map.Add($vpd_count, $count)
        $Global:__ch_vpd_revmap.Add($count, $vpd_count)
}


function filter_chelsio_card ([int] $count)
{
        $chelsio_card_count = 0
        for ($i=0; $i -le $count; $i++){
                $dev, $part = get_pci_device ($i)
                $st, $name = __is_chelsio_card ($dev)
                if ($st -eq $true) {
                        __add_device $i $chelsio_card_count $name $part
                        $chelsio_card_count +=1
                }

        }
}

function choose_adapter ()
{
        Write-Host "`nSelect the Adapter"
        foreach ( $key in ($__ch_cards.GetEnumerator() | Sort-Object Name)){
                $cnt = [convert]::ToInt32($key.name, 10)              
                $display = $Global:__ch_vpd_map.Item($cnt) +1
                $tmp = "{0,7}{1,2}{2,1}{3,-15}{4,-18}" -f ` "", $display, ".", $key.value, $Global:__ch_parts.Item($cnt)
           
                Write-Host $tmp
        } 

        $choice = Read-Host "Input "
        try {
                $choice = [convert]::ToInt32($choice, 10)
        }
        catch {
                Write-Host "Please enter valid input to select adapter"
                exit (1)
        }

        if (-Not ($choice -ge 1 -and $choice -le  $__ch_cards.Count)){
                Write-Host "Please enter valid input to select adapter"
                exit (1)
        }

        return $Global:__ch_vpd_revmap.item($choice-1)


}

function is_t6([string] $adapter_name)
{
        if ($adapter_name[1] -eq '6') {
                return 1
        }

        return 0;
}

function is_t62100([string] $adapter_name)
{
        if($adapter_name -match "T6.*100.*"){
                return 1
        }

        return 0
}

function is_t6225([string] $adapter_name)
{
        if($adapter_name -match "T6.*225.*"){
                return 1
        }

        return 0
}

function is_t580([string] $adapter_name)
{
        if($adapter_name[2] -eq '8' -and $adapter_name[3] -eq '0'){
                return 1
        }
        return 0;

}

function choose_vpd([string] $adapter_name)
{
        Write-Host "`nChoose the type:"
        Write-Host "`t1. DEFAULT [T5(2 * 40G)/ T6(2 * 100)]"
        $t6225 = is_t6225 $adapter_name
        if (!$t6225) {
                Write-Host "`t2. SPIDER  [T5(4 x 10G)/ T6 (NA)]"
                Write-Host "`t3. QSA     [T5(2 x 10G)/ T6 (NA)]"
        }
        
        $adapter_name = $Global:__ch_cards.Item($adapter)  

        $choice = Read-Host "Input "
        try {
                $choice = [convert]::ToInt32($choice, 10)
        }
        catch {
                Write-Host "Please enter valid input !!"
                exit (1)
        }
        if ($choice -ne 1 -and $choice -ne 2 -and $choice -ne 3){
                Write-Host "Please enter valid input !!"
                exit(1)
        }

        if ($adapter_name -eq "T580-OCP-SO" -and $choice -eq 3) {
                Write-Host "QSA is not supported for T580-OCP-SO"
                exit(1)
        }


        if (is_t6225($adapter_name)) {
            if ($choice -gt 1) {
                    Write-Host "Wrong Input" -ForegroundColor Red
                    exit(1)
            }
        }

        if (is_t62100($adapter_name)) {
                if ($choice -gt 1) {
                        Write-Host "SPIDER/QSA is not supported in T6 yet" -ForegroundColor Red
                        exit(1)
                }
        }
        return $choice
}

function choose_init ()
{
        Write-Host "`nChoose the configuration type:"
        Write-Host "`t1. NON-SRIOV (Default)"
        Write-Host "`t2. SRIOV"
        
        $adapter_name = $Global:__ch_cards.Item($adapter)
        
        $t580 = is_t580 $adapter_name
        $t6 = is_t6 $adapter_name
        #if ($t580 -or $t6 ){
        if ($t580){
                Write-Host "`t3. Port settings"
        }

        $choice = Read-Host "Input "
        try {
                $choice = [convert]::ToInt32($choice, 10)
        }
        catch {
                Write-Host "Please enter valid input !!"
                exit (1)
        }
        if ($choice -ne 1 -and $choice -ne 2 -and $choice -ne 3){
                Write-Host "Please enter valid input !!"
                exit(1)
        }
        
        #if (is_t6($adapter_name)) {
        #        if ($choice -eq 2) {
        #                Write-Host "SRIOV is not supported in T6 yet"
        #                exit(1)
        #        }
        #}

        return $choice
}

function __yes_no_flash ()
{
        $choice = Read-Host "Do you want to continue (y/n)"

        Set-Content tmp $choice
        if ($choice  -eq 'y' -or $choice -eq 'Y'){
                return $true
        }
        if ($choice -ne 'n' -and $choice -ne 'N'){
                Write-Host "Invalid input!"
        }
        
        Remove-Item tmp
        exit(1)
}
    
function __flash ($vpd, $path)
{     
        $out = __verify $vpd $path $false
        if ( ($out -join '`n').Contains("FAILED") -eq $false) {
                Write-Host "`nThe selected configuration is already present." -ForegroundColor Green
                exit(0)
        }

        $out = [string]

        # Exit if the user says not to flash
        $choice = __yes_no_flash 
 
        $path = "`"$path`""
        # Start the process and attact the user input as the
        # standard input file. 
        
        if ( is_ms_nano_server ) {
            Start-Process (get_cxgbtool) -ArgumentList vbd$vpd,serialinit,write,$path,force -RedirectStandardInput tmp -RedirectStandardOutput out0 -wait -NoNewWindow
        }
        else {
            Start-Process (get_cxgbtool) -ArgumentList vbd$vpd,serialinit,write,$path -RedirectStandardInput tmp -RedirectStandardOutput out0 -wait -NoNewWindow
        }

        $out = Get-Content out0
        #Write-Host `n

        Remove-Item tmp
        Remove-Item out0
        
        if ( ($out -join '`n').Contains('fail') -eq $true){
                Write-Host "Flashing failed with error `n $out" -ForegroundColor Red
                exit(1)
        }
       
}

function __flash_vpd ($vpd, $path)
{     
        $out = __verify_vpd $vpd $path $false
        if ( ($out -join '`n').Contains("FAILED") -eq $false) {
                Write-Host "`nThe selected configuration is already present." -ForegroundColor Green
                exit(0)
        }

        $out = [string]

        # Exit if the user says not to flash
        $choice = __yes_no_flash 
 
        $path = "`"$path`""
        # Start the process and attact the user input as the
        # standard input file. 
        if ( is_ms_nano_server ) {
            Start-Process (get_cxgbtool) -ArgumentList vbd$vpd,vpd,write,$path,force -RedirectStandardInput tmp -RedirectStandardOutput out0 -Wait -NoNewWindow
        }
        else {
            Start-Process (get_cxgbtool) -ArgumentList vbd$vpd,vpd,write,$path -RedirectStandardInput tmp -RedirectStandardOutput out0 -Wait -NoNewWindow
        } 

        $out = Get-Content out0
      
        Remove-Item tmp
        Remove-Item out0
      
        if ( ($out -join '`n').Contains('fail') -eq $true){
                Write-Host "Flashing failed with error `n $out" -ForegroundColor Red
                exit(1)
        }
       
}

function __verify_vpd ($vpd, $path, $debug)
{
      
        #if ( $debug -eq $true){
        #        Write-Host -NoNewline "`nVerifying the existing configuration... " -ForegroundColor Green
        #}

        $cmd = "$(get_cxgbtool) vbd$vpd vpd verify `"$path`""
        
        $out = Invoke-Expression -Command $cmd 
       
        return $out

}


function __verify ($vpd, $path, $debug)
{
      
        #if ( $debug -eq $true){
        #        Write-Host -NoNewline "`nVerifying the existing configuration... " -ForegroundColor Green
        #}

        $cmd = "$(get_cxgbtool) vbd$vpd serialinit verify `"$path`""
        $out = Invoke-Expression -Command $cmd 
        #Write-Host $cmd
        return $out

}

function __get_default_init ([string] $adapter_name)
{
        $file_name = $Global:__default_init.Item($adapter_name)
        if (!$file_name) {
             Write-Host "Init file not provided"
             exit(1)   
        }

        if ( (Test-Path  "$Global:__sys_drive\ChelsioUwire\Adapter Configuration\default\$file_name") -eq $true){
                return "$Global:__sys_drive\ChelsioUwire\Adapter` Configuration\default\$file_name"
        }
        elseif ( (Test-Path ".\default\$file_name") -eq $true){
                return  ".\default\$file_name"
        }
        else {
                return $file_name
        }
}


function __get_sriov  ([string] $adapter_name)
{

        $file_name = $Global:__sriov.Item($adapter_name)

        if ( (Test-Path "$Global:__sys_drive\ChelsioUwire\Adapter Configuration\SRIOV\$file_name") -eq $true){
                return "$Global:__sys_drive\ChelsioUwire\Adapter` Configuration\SRIOV\$file_name"
        }
        elseif ( (Test-Path ".\SRIOV\$file_name") -eq $true){
                return  ".\SRIOV\$file_name"
        }
        else {
                return $file_name
        }
}

 
function __check_init_path ($path)
{
        $ret = Test-Path $path 
        if ($ret -eq $false){
                Write-Host "Unable to find the bin file." -ForegroundColor Red
                exit (1)
        }

}

function __get_vpd([string] $adapter_name, [int] $vpd_choice)
{

        if ($vpd_choice -eq 1){
                $file_name = $Global:__vpd_default.Item($adapter_name)
                                
        }
        elseif ($vpd_choice -eq 2){
                 $file_name = $Global:__vpd_spider.Item($adapter_name)
        }
        elseif ($vpd_choice -eq 3){
                 $file_name = $Global:__vpd_qsa.Item($adapter_name)
        }
        if (!$file_name) {
            Write-Host "VPD File not provided"
            exit(1)
        }
       
        if ( (Test-Path "$Global:__sys_drive\ChelsioUwire\Adapter Configuration\Port Settings\$file_name") -eq $true){
                return "$Global:__sys_drive\ChelsioUwire\Adapter` Configuration\Port` Settings\$file_name"
        }
        elseif ( (Test-Path ".\Port Settings\$file_name") -eq $true){
                return  ".\Port` Settings\$file_name"
        }
        else {
                return $file_name
        }
}

function flash ([int] $adapter, [int] $init)
{
        $adapter_name = $Global:__ch_cards.Item($adapter)
        $t5 = is_t580 $adapter_name
        $t6 = is_t6 $adapter_name
        
        if ($init -eq 1){
                $init_file = __get_default_init ($adapter_name)    
        }elseif ($init -eq 2){
                $init_file = __get_sriov ($adapter_name)
                #Write-Host "adap $adapter_name"
                #Write-Host "sriov init $init_file"
                
        }elseif ($init -eq 3 -and ($t5 -or $t6)){
                $vpd_choice = choose_vpd $adapter_name
                $init_file = __get_vpd $adapter_name $vpd_choice            

        }else {
                Write-Host "Please Enter valid input !!!"
                exit(1)
        }

        __check_init_path ($init_file)
        
        if ($init -eq 3){
                __flash_vpd $adapter $init_file
                $out = __verify_vpd $adapter $init_file $true
        }else {
                __flash $adapter $init_file
                $out = __verify $adapter $init_file $true
        }
        
        #Write-Host $out
        if (($out -join '`n').Contains("FAILED")) {
                #Write-Host $out
                Write-Host "`nVerification Failed." -ForegroundColor Red
                exit(1)
        }
        else {
                Write-Host "Successfully updated the selected configuration type." -ForegroundColor Green
                Write-Host "`nVerification: Passed" -ForegroundColor Green
                Write-Host "`nPlease reboot the machine for changes to take effect." -ForegroundColor Red
        }
}

function main (){

        if ((is_ms_nano_server) -and ((is_cxgbnano_present) -eq $false) ) {
                Write-Host "cxgbnano is not present in system32 folder." -ForegroundColor Red
                exit(1)
        }


        if (!(is_ms_nano_server) -and ((is_cxgbtool_present ) -eq $false)){
                Write-Host "cxgbtool is not present in system32 folder." -ForegroundColor Red
                exit(1)
        }
        
        Write-Host "`nchelsio_adapter_config Version $Global:__version__`n"
        Write-Host "Please stop all the traffic on Chelsio adapters before updating !!" -ForegroundColor Red
        $count = get_chelsio_card_count
        filter_chelsio_card ($count)
        $adapter = choose_adapter
        $init = choose_init
 
        flash $adapter $init
}

main 

# SIG # Begin signature block
# MIIcCAYJKoZIhvcNAQcCoIIb+TCCG/UCAQExDzANBglghkgBZQMEAgEFADB5Bgor
# BgEEAYI3AgEEoGswaTA0BgorBgEEAYI3AgEeMCYCAwEAAAQQH8w7YFlLCE63JNLG
# KX7zUQIBAAIBAAIBAAIBAAIBADAxMA0GCWCGSAFlAwQCAQUABCD4I+qKQtYx6Uo6
# TDy4zLh3AwwCiymC3K6KCgYToQJ/UqCCFtQwggO3MIICn6ADAgECAhAM5+DlF9hG
# /o/lYPwb8DA5MA0GCSqGSIb3DQEBBQUAMGUxCzAJBgNVBAYTAlVTMRUwEwYDVQQK
# EwxEaWdpQ2VydCBJbmMxGTAXBgNVBAsTEHd3dy5kaWdpY2VydC5jb20xJDAiBgNV
# BAMTG0RpZ2lDZXJ0IEFzc3VyZWQgSUQgUm9vdCBDQTAeFw0wNjExMTAwMDAwMDBa
# Fw0zMTExMTAwMDAwMDBaMGUxCzAJBgNVBAYTAlVTMRUwEwYDVQQKEwxEaWdpQ2Vy
# dCBJbmMxGTAXBgNVBAsTEHd3dy5kaWdpY2VydC5jb20xJDAiBgNVBAMTG0RpZ2lD
# ZXJ0IEFzc3VyZWQgSUQgUm9vdCBDQTCCASIwDQYJKoZIhvcNAQEBBQADggEPADCC
# AQoCggEBAK0OFc7kQ4BcsYfzt2D5cRKlrtwmlIiq9M71IDkoWGAM+IDaqRWVMmE8
# tbEohIqK3J8KDIMXeo+QrIrneVNcMYQq9g+YMjZ2zN7dPKii72r7IfJSYd+fINcf
# 4rHZ/hhk0hJbX/lYGDW8R82hNvlrf9SwOD7BG8OMM9nYLxj+KA+zp4PWw25EwGE1
# lhb+WZyLdm3X8aJLDSv/C3LanmDQjpA1xnhVhyChz+VtCshJfDGYM2wi6YfQMlqi
# uhOCEe05F52ZOnKh5vqk2dUXMXWuhX0irj8BRob2KHnIsdrkVxfEfhwOsLSSplaz
# vbKX7aqn8LfFqD+VFtD/oZbrCF8Yd08CAwEAAaNjMGEwDgYDVR0PAQH/BAQDAgGG
# MA8GA1UdEwEB/wQFMAMBAf8wHQYDVR0OBBYEFEXroq/0ksuCMS1Ri6enIZ3zbcgP
# MB8GA1UdIwQYMBaAFEXroq/0ksuCMS1Ri6enIZ3zbcgPMA0GCSqGSIb3DQEBBQUA
# A4IBAQCiDrzf4u3w43JzemSUv/dyZtgy5EJ1Yq6H6/LV2d5Ws5/MzhQouQ2XYFwS
# TFjk0z2DSUVYlzVpGqhH6lbGeasS2GeBhN9/CTyU5rgmLCC9PbMoifdf/yLil4Qf
# 6WXvh+DfwWdJs13rsgkq6ybteL59PyvztyY1bV+JAbZJW58BBZurPSXBzLZ/wvFv
# hsb6ZGjrgS2U60K3+owe3WLxvlBnt2y98/Efaww2BxZ/N3ypW2168RJGYIPXJwS+
# S86XvsNnKmgR34DnDDNmvxMNFG7zfx9jEB76jRslbWyPpbdhAbHSoyahEHGdreLD
# +cOZUbcrBwjOLuZQsqf6CkUvovDyMIID7jCCA1egAwIBAgIQfpPr+3zGTlnqS5p3
# 1Ab8OzANBgkqhkiG9w0BAQUFADCBizELMAkGA1UEBhMCWkExFTATBgNVBAgTDFdl
# c3Rlcm4gQ2FwZTEUMBIGA1UEBxMLRHVyYmFudmlsbGUxDzANBgNVBAoTBlRoYXd0
# ZTEdMBsGA1UECxMUVGhhd3RlIENlcnRpZmljYXRpb24xHzAdBgNVBAMTFlRoYXd0
# ZSBUaW1lc3RhbXBpbmcgQ0EwHhcNMTIxMjIxMDAwMDAwWhcNMjAxMjMwMjM1OTU5
# WjBeMQswCQYDVQQGEwJVUzEdMBsGA1UEChMUU3ltYW50ZWMgQ29ycG9yYXRpb24x
# MDAuBgNVBAMTJ1N5bWFudGVjIFRpbWUgU3RhbXBpbmcgU2VydmljZXMgQ0EgLSBH
# MjCCASIwDQYJKoZIhvcNAQEBBQADggEPADCCAQoCggEBALGss0lUS5ccEgrYJXmR
# Ilcqb9y4JsRDc2vCvy5QWvsUwnaOQwElQ7Sh4kX06Ld7w3TMIte0lAAC903tv7S3
# RCRrzV9FO9FEzkMScxeCi2m0K8uZHqxyGyZNcR+xMd37UWECU6aq9UksBXhFpS+J
# zueZ5/6M4lc/PcaS3Er4ezPkeQr78HWIQZz/xQNRmarXbJ+TaYdlKYOFwmAUxMjJ
# OxTawIHwHw103pIiq8r3+3R8J+b3Sht/p8OeLa6K6qbmqicWfWH3mHERvOJQoUvl
# XfrlDqcsn6plINPYlujIfKVOSET/GeJEB5IL12iEgF1qeGRFzWBGflTBE3zFefHJ
# wXECAwEAAaOB+jCB9zAdBgNVHQ4EFgQUX5r1blzMzHSa1N197z/b7EyALt0wMgYI
# KwYBBQUHAQEEJjAkMCIGCCsGAQUFBzABhhZodHRwOi8vb2NzcC50aGF3dGUuY29t
# MBIGA1UdEwEB/wQIMAYBAf8CAQAwPwYDVR0fBDgwNjA0oDKgMIYuaHR0cDovL2Ny
# bC50aGF3dGUuY29tL1RoYXd0ZVRpbWVzdGFtcGluZ0NBLmNybDATBgNVHSUEDDAK
# BggrBgEFBQcDCDAOBgNVHQ8BAf8EBAMCAQYwKAYDVR0RBCEwH6QdMBsxGTAXBgNV
# BAMTEFRpbWVTdGFtcC0yMDQ4LTEwDQYJKoZIhvcNAQEFBQADgYEAAwmbj3nvf1kw
# qu9otfrjCR27T4IGXTdfplKfFo3qHJIJRG71betYfDDo+WmNI3MLEm9Hqa45Efgq
# sZuwGsOO61mWAK3ODE2y0DGmCFwqevzieh1XTKhlGOl5QGIllm7HxzdqgyEIjkHq
# 3dlXPx13SYcqFgZepjhqIhKjURmDfrYwggSjMIIDi6ADAgECAhAOz/Q4yP6/NW4E
# 2GqYGxpQMA0GCSqGSIb3DQEBBQUAMF4xCzAJBgNVBAYTAlVTMR0wGwYDVQQKExRT
# eW1hbnRlYyBDb3Jwb3JhdGlvbjEwMC4GA1UEAxMnU3ltYW50ZWMgVGltZSBTdGFt
# cGluZyBTZXJ2aWNlcyBDQSAtIEcyMB4XDTEyMTAxODAwMDAwMFoXDTIwMTIyOTIz
# NTk1OVowYjELMAkGA1UEBhMCVVMxHTAbBgNVBAoTFFN5bWFudGVjIENvcnBvcmF0
# aW9uMTQwMgYDVQQDEytTeW1hbnRlYyBUaW1lIFN0YW1waW5nIFNlcnZpY2VzIFNp
# Z25lciAtIEc0MIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEAomMLOUS4
# uyOnREm7Dv+h8GEKU5OwmNutLA9KxW7/hjxTVQ8VzgQ/K/2plpbZvmF5C1vJTIZ2
# 5eBDSyKV7sIrQ8Gf2Gi0jkBP7oU4uRHFI/JkWPAVMm9OV6GuiKQC1yoezUvh3WPV
# F4kyW7BemVqonShQDhfultthO0VRHc8SVguSR/yrrvZmPUescHLnkudfzRC5xINk
# lBm9JYDh6NIipdC6Anqhd5NbZcPuF3S8QYYq3AhMjJKMkS2ed0QfaNaodHfbDlsy
# i1aLM73ZY8hJnTrFxeozC9Lxoxv0i77Zs1eLO94Ep3oisiSuLsdwxb5OgyYI+wu9
# qU+ZCOEQKHKqzQIDAQABo4IBVzCCAVMwDAYDVR0TAQH/BAIwADAWBgNVHSUBAf8E
# DDAKBggrBgEFBQcDCDAOBgNVHQ8BAf8EBAMCB4AwcwYIKwYBBQUHAQEEZzBlMCoG
# CCsGAQUFBzABhh5odHRwOi8vdHMtb2NzcC53cy5zeW1hbnRlYy5jb20wNwYIKwYB
# BQUHMAKGK2h0dHA6Ly90cy1haWEud3Muc3ltYW50ZWMuY29tL3Rzcy1jYS1nMi5j
# ZXIwPAYDVR0fBDUwMzAxoC+gLYYraHR0cDovL3RzLWNybC53cy5zeW1hbnRlYy5j
# b20vdHNzLWNhLWcyLmNybDAoBgNVHREEITAfpB0wGzEZMBcGA1UEAxMQVGltZVN0
# YW1wLTIwNDgtMjAdBgNVHQ4EFgQURsZpow5KFB7VTNpSYxc/Xja8DeYwHwYDVR0j
# BBgwFoAUX5r1blzMzHSa1N197z/b7EyALt0wDQYJKoZIhvcNAQEFBQADggEBAHg7
# tJEqAEzwj2IwN3ijhCcHbxiy3iXcoNSUA6qGTiWfmkADHN3O43nLIWgG2rYytG2/
# 9CwmYzPkSWRtDebDZw73BaQ1bHyJFsbpst+y6d0gxnEPzZV03LZc3r03H0N45ni1
# zSgEIKOq8UvEiCmRDoDREfzdXHZuT14ORUZBbg2w6jiasTraCXEQ/Bx5tIB7rGn0
# /Zy2DBYr8X9bCT2bW+IWyhOBbQAuOA2oKY8s4bL0WqkBrxWcLC9JG9siu8P+eJRR
# w4axgohd8D20UaF5Mysue7ncIAkTcetqGVvP6KUwVyyJST+5z3/Jvz4iaGNTmr1p
# dKzFHTx/kuDDvBzYBHUwggUwMIIEGKADAgECAhAECRgbX9W7ZnVTQ7VvlVAIMA0G
# CSqGSIb3DQEBCwUAMGUxCzAJBgNVBAYTAlVTMRUwEwYDVQQKEwxEaWdpQ2VydCBJ
# bmMxGTAXBgNVBAsTEHd3dy5kaWdpY2VydC5jb20xJDAiBgNVBAMTG0RpZ2lDZXJ0
# IEFzc3VyZWQgSUQgUm9vdCBDQTAeFw0xMzEwMjIxMjAwMDBaFw0yODEwMjIxMjAw
# MDBaMHIxCzAJBgNVBAYTAlVTMRUwEwYDVQQKEwxEaWdpQ2VydCBJbmMxGTAXBgNV
# BAsTEHd3dy5kaWdpY2VydC5jb20xMTAvBgNVBAMTKERpZ2lDZXJ0IFNIQTIgQXNz
# dXJlZCBJRCBDb2RlIFNpZ25pbmcgQ0EwggEiMA0GCSqGSIb3DQEBAQUAA4IBDwAw
# ggEKAoIBAQD407Mcfw4Rr2d3B9MLMUkZz9D7RZmxOttE9X/lqJ3bMtdx6nadBS63
# j/qSQ8Cl+YnUNxnXtqrwnIal2CWsDnkoOn7p0WfTxvspJ8fTeyOU5JEjlpB3gvmh
# hCNmElQzUHSxKCa7JGnCwlLyFGeKiUXULaGj6YgsIJWuHEqHCN8M9eJNYBi+qsSy
# rnAxZjNxPqxwoqvOf+l8y5Kh5TsxHM/q8grkV7tKtel05iv+bMt+dDk2DZDv5LVO
# pKnqagqrhPOsZ061xPeM0SAlI+sIZD5SlsHyDxL0xY4PwaLoLFH3c7y9hbFig3NB
# ggfkOItqcyDQD2RzPJ6fpjOp/RnfJZPRAgMBAAGjggHNMIIByTASBgNVHRMBAf8E
# CDAGAQH/AgEAMA4GA1UdDwEB/wQEAwIBhjATBgNVHSUEDDAKBggrBgEFBQcDAzB5
# BggrBgEFBQcBAQRtMGswJAYIKwYBBQUHMAGGGGh0dHA6Ly9vY3NwLmRpZ2ljZXJ0
# LmNvbTBDBggrBgEFBQcwAoY3aHR0cDovL2NhY2VydHMuZGlnaWNlcnQuY29tL0Rp
# Z2lDZXJ0QXNzdXJlZElEUm9vdENBLmNydDCBgQYDVR0fBHoweDA6oDigNoY0aHR0
# cDovL2NybDQuZGlnaWNlcnQuY29tL0RpZ2lDZXJ0QXNzdXJlZElEUm9vdENBLmNy
# bDA6oDigNoY0aHR0cDovL2NybDMuZGlnaWNlcnQuY29tL0RpZ2lDZXJ0QXNzdXJl
# ZElEUm9vdENBLmNybDBPBgNVHSAESDBGMDgGCmCGSAGG/WwAAgQwKjAoBggrBgEF
# BQcCARYcaHR0cHM6Ly93d3cuZGlnaWNlcnQuY29tL0NQUzAKBghghkgBhv1sAzAd
# BgNVHQ4EFgQUWsS5eyoKo6XqcQPAYPkt9mV1DlgwHwYDVR0jBBgwFoAUReuir/SS
# y4IxLVGLp6chnfNtyA8wDQYJKoZIhvcNAQELBQADggEBAD7sDVoks/Mi0RXILHwl
# KXaoHV0cLToaxO8wYdd+C2D9wz0PxK+L/e8q3yBVN7Dh9tGSdQ9RtG6ljlriXiSB
# ThCk7j9xjmMOE0ut119EefM2FAaK95xGTlz/kLEbBw6RFfu6r7VRwo0kriTGxycq
# oSkoGjpxKAI8LpGjwCUR4pwUR6F6aGivm6dcIFzZcbEMj7uo+MUSaJ/PQMtARKUT
# 8OZkDCUIQjKyNookAv4vcn4c10lFluhZHen6dGRrsutmQ9qzsIzV6Q3d9gEgzpkx
# Yz0IGhizgZtPxpMQBvwHgfqL2vmCSfdibqFT+hKUGIUukpHqaGxEMrJmoecYpJpk
# Ue8wggVIMIIEMKADAgECAhAFk4fAXzROCjuGouiMcXQLMA0GCSqGSIb3DQEBCwUA
# MHIxCzAJBgNVBAYTAlVTMRUwEwYDVQQKEwxEaWdpQ2VydCBJbmMxGTAXBgNVBAsT
# EHd3dy5kaWdpY2VydC5jb20xMTAvBgNVBAMTKERpZ2lDZXJ0IFNIQTIgQXNzdXJl
# ZCBJRCBDb2RlIFNpZ25pbmcgQ0EwHhcNMTYwMzI1MDAwMDAwWhcNMTcwNTMxMTIw
# MDAwWjCBhDELMAkGA1UEBhMCVVMxEzARBgNVBAgTCkNhbGlmb3JuaWExEjAQBgNV
# BAcTCVN1bm55dmFsZTElMCMGA1UEChMcQ2hlbHNpbyBDb21tdW5pY2F0aW9ucywg
# SW5jLjElMCMGA1UEAxMcQ2hlbHNpbyBDb21tdW5pY2F0aW9ucywgSW5jLjCCASIw
# DQYJKoZIhvcNAQEBBQADggEPADCCAQoCggEBAJs6IsplBYm79QRTneNo/zQ0o7WY
# LdgIbD9ktqxt/pxILpUBUgCnIfTAZfcBwzKxYLKhqQyaG63vhnG3U3xfOJILYxIh
# 55nILZ4SU8n/bYcyVOnY7hZieyAGMwWYZ4Lj3UFOJc+fQYyRxRVEm7T4xzzNXQ3o
# hbEDRXEn/Kb+XJ7ijYfee3OAs5pqraZC5kT6ZyPrrzOcZzqf/V/DkjDpdNf9L3pM
# PvEkzdiCvtu9Nbh09uEXax/yZNzE5viMwd4gvGNUQkW25bYqCzpIOSh5Pj7kYwms
# +2JxJaYyerQ/vZsi7dwkCMIMxVUtk6aZUex/jTNyNZ19ebaSnbNXvwHBXdECAwEA
# AaOCAcUwggHBMB8GA1UdIwQYMBaAFFrEuXsqCqOl6nEDwGD5LfZldQ5YMB0GA1Ud
# DgQWBBQH8qGj9Vzd/MXlQ5fbFyVGpNc11TAOBgNVHQ8BAf8EBAMCB4AwEwYDVR0l
# BAwwCgYIKwYBBQUHAwMwdwYDVR0fBHAwbjA1oDOgMYYvaHR0cDovL2NybDMuZGln
# aWNlcnQuY29tL3NoYTItYXNzdXJlZC1jcy1nMS5jcmwwNaAzoDGGL2h0dHA6Ly9j
# cmw0LmRpZ2ljZXJ0LmNvbS9zaGEyLWFzc3VyZWQtY3MtZzEuY3JsMEwGA1UdIARF
# MEMwNwYJYIZIAYb9bAMBMCowKAYIKwYBBQUHAgEWHGh0dHBzOi8vd3d3LmRpZ2lj
# ZXJ0LmNvbS9DUFMwCAYGZ4EMAQQBMIGEBggrBgEFBQcBAQR4MHYwJAYIKwYBBQUH
# MAGGGGh0dHA6Ly9vY3NwLmRpZ2ljZXJ0LmNvbTBOBggrBgEFBQcwAoZCaHR0cDov
# L2NhY2VydHMuZGlnaWNlcnQuY29tL0RpZ2lDZXJ0U0hBMkFzc3VyZWRJRENvZGVT
# aWduaW5nQ0EuY3J0MAwGA1UdEwEB/wQCMAAwDQYJKoZIhvcNAQELBQADggEBAIZm
# DlRJFUg8j8n0cYAA0Po7O9S7oNG2XeU0WWMKu9NIRXH+oobPebDtQAq3IiInSmE+
# qF9D7t8v5HOJ90rNCitBm3iUtZTjo5BfBN7SlFfmmw9VuqgoRilSs8natmGzyJ69
# 5bu7fUib3ebaNmVsGVtktsnfBBqVOO4nn1fgryrmY+JN5iFjC2Pr5c4O7kyN4o2M
# 0UR9dTWJflbuprIGWHHvCcxNWK/qaWyJuzvnB71o+54gALQmhcE6gt46NmEhT4ec
# wEMVhFS2c1CDirhZFQ9x1OwDEl+h67tIH0c29Lz+8ZHJGoreOH6pQ7RuwVOn8O8I
# 0byoiaXumsaRXgYvCZsxggSKMIIEhgIBATCBhjByMQswCQYDVQQGEwJVUzEVMBMG
# A1UEChMMRGlnaUNlcnQgSW5jMRkwFwYDVQQLExB3d3cuZGlnaWNlcnQuY29tMTEw
# LwYDVQQDEyhEaWdpQ2VydCBTSEEyIEFzc3VyZWQgSUQgQ29kZSBTaWduaW5nIENB
# AhAFk4fAXzROCjuGouiMcXQLMA0GCWCGSAFlAwQCAQUAoIHGMBkGCSqGSIb3DQEJ
# AzEMBgorBgEEAYI3AgEEMBwGCisGAQQBgjcCAQsxDjAMBgorBgEEAYI3AgEVMC8G
# CSqGSIb3DQEJBDEiBCAF0fh4GVwmitL3QRowfiefnFAuJzb05TNYliuwtoDE3zBa
# BgorBgEEAYI3AgEMMUwwSqAugCwAYwBoAGUAbABzAGkAbwBfAGEAZABhAHAAdABl
# AHIAXwBjAG8AbgBmAGkAZ6EYgBZodHRwOi8vd3d3LmNoZWxzaW8uY29tMA0GCSqG
# SIb3DQEBAQUABIIBADSdIf6U+Ovd55xPi9j712q1Cq98U9vxbCh7zdGXaY5WFQrL
# myE5+Ms98iY74xI32yX8JOhkTIiHvlBEpMUlvlP3kdXtCrdw3QQb8bvqYChaNg35
# 1jIC2o718S2V9pAieF1NLb/6a96jQcxEXXG3xyn+VNKvWInaUm4XELoN6NOyqpMX
# lEGh8K0OmDCrOMZ6M3jXE483KDbODrwFwT1AzHRW/o4IlLD3uGBOjQ5dqVHlR191
# MZciA9Q/EQXzcUkq5cPyOaSsQR4fIZB0vujnDrXXmiCNsug2YHXnn66bY+Iv5Xgl
# PNHqskNXvIYOePNHuGh5fdIoetjMC8+U/qjQIoyhggILMIICBwYJKoZIhvcNAQkG
# MYIB+DCCAfQCAQEwcjBeMQswCQYDVQQGEwJVUzEdMBsGA1UEChMUU3ltYW50ZWMg
# Q29ycG9yYXRpb24xMDAuBgNVBAMTJ1N5bWFudGVjIFRpbWUgU3RhbXBpbmcgU2Vy
# dmljZXMgQ0EgLSBHMgIQDs/0OMj+vzVuBNhqmBsaUDAJBgUrDgMCGgUAoF0wGAYJ
# KoZIhvcNAQkDMQsGCSqGSIb3DQEHATAcBgkqhkiG9w0BCQUxDxcNMTYxMjI5MTA0
# MzAzWjAjBgkqhkiG9w0BCQQxFgQUw43QfY98hOQwl1S+DXv3ueHJyOUwDQYJKoZI
# hvcNAQEBBQAEggEALUpEA80mANguvCpz6/+CPhXXAjG809X5U+PWP6rgWf19RloH
# MskQVOSfL1M88/m4fmShdAz0DGpjkvUE0mnvR5kinKupoBOBP2JO4pXhG6j3eB0B
# /eOG9NEiskip5S0EDynNDl6vis00jH+q4sumgV6SPxasI2KZP7V3WRMt7NjXpM/f
# fQAYPWaVBmAqPQ96ZmLeVXLfWJmWO89AGWEbBUL9o3juBWZ0SJcB/EuxJoAORIK9
# qEkDIIbkNk0vWc36wEjSgS6p8E1CF+XdBJQiwrRBnoqzX2jo27hTosWBwnH4DCgR
# cpBtwmhcclJkFSXg/Psjv2my+4ku1BVF0X1ewg==
# SIG # End signature block
